Subject: bug#12935: 24.3.50; `load-file' handling of "el[c]" extension

From: "Drew Adams" <[email-masked]>
Date: Mon, 19 Nov 2012 09:30:39 -0800

Perhaps an enhancement request.  But if there is a good reason not to do
this then please close the request.  IOW, more of a question than an
outright request.
 
In Emacs 20, this is the behavior for `load-file'.  I have a library
icicles-cmd1.el, which requires library icicles-mac.el[c].  I do this:
 
M-x load-file RET icicles-cmd1 RET
 
Emacs offers this:
 
Load file: c:/the-dir/icicles-cmd1.el [Confirm]
 
I hit RET.  Emacs says this: Cannot open load file: icicles-mac.
 
That behavior seems helpful to me.  And if I do this in `the-dir':
 
M-: (add-to-list 'load-path ".") ; then this is the interaction:
 
M-x load-file RET icicles-cmd1 RET
Emacs offers this:
Load file: c:/the-dir/icicles-cmd1.el [Confirm]
I hit RET.  Emacs loads icicles-mac.el[c] and then icicles-cmd1.el.
 
This behavior all seems good, to me.
 
Contrast that with Emacs 22 and later (I did not check 21):
 
M-x load-file RET icicles-cmd1
 
Emacs says this immediately: Cannot open load file: icicles-cmd1.
IOW, it does not try for icicles-cmd1.el, asking for confirmation.
 
Then:
M-: (add-to-list 'load-path ".")
M-x load-file RET icicles-cmd1 RET
 
Emacs still says only: Cannot open load file: icicles-cmd1.
 
Not very helpful.  Would you agree that this could be improved, and that
the Emacs 20 behavior in this regard is better?
 
Yes, I am aware that the doc (even for Emacs 20) says that `load-file'
does not take `load-path' into account.  I am not claiming that the
behavior is a bug.  I am asking whether it is as good as it could be.
 
And the handling of `load-path' can be separated from the intial
completion and asking for confirmation of the .el file.  That by
itself seems like an improvement.
 
Perhaps there is a downside to the Emacs 20 behavior that I'm not
seeing, looking narrowly at only this one scenario.
 
In GNU Emacs 24.3.50.1 (i386-mingw-nt5.1.2600) of 2012-11-05 on
 MS-W7-DANI Bzr revision: 110809
 [email-masked] Windowing system
 distributor `Microsoft Corp.', version 5.1.2600 Configured using:
 `configure --with-gcc (4.7) --no-opt --enable-checking --cflags
 -I../../libs/libXpm-3.5.10/include -I../../libs/libXpm-3.5.10/src
 -I../../libs/libpng-1.2.37-lib/include -I../../libs/zlib-1.2.5
 -I../../libs/giflib-4.1.4-1-lib/include
 -I../../libs/jpeg-6b-4-lib/include
 -I../../libs/tiff-3.8.2-1-lib/include
 -I../../libs/libxml2-2.7.8-w32-bin/include/libxml2
 -I../../libs/gnutls-3.0.9-w32-bin/include
 -I../../libs/libiconv-1.9.2-1-lib/include'